/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARAMCMPPROD                                             */
/* Tabela : PARAMCMPPROD                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 07/10/2003 - Marina Amaral                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PARAMCMPPROD
BEFORE INSERT OR UPDATE OR DELETE
ON PARAMCMPPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPCOM := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0)     <> NVL(:NEW.CDFILIAL,0))    OR
         (NVL(:OLD.CDPRODUTO,0)    <> NVL(:NEW.CDPRODUTO,0))   OR
         (NVL(:OLD.IDBLOQNFSAF,0)  <> NVL(:NEW.IDBLOQNFSAF,0)) OR
         (NVL(:OLD.DTULTATUPCOM,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTULTATUPCOM,TO_DATE('31/12/1899','DD/MM/YYYY'))) THEN
         :NEW.DTULTATUPCOM := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PARAMCMPPROD', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PARAMCMPPROD MODIFY DTULTATUPCOM DEFAULT SYSDATE
/
